package com.dzeio.openhealth.adapters

import android.util.Log
import android.view.LayoutInflater
import android.view.ViewGroup
import com.dzeio.openhealth.core.BaseAdapter
import com.dzeio.openhealth.core.BaseViewHolder
import com.dzeio.openhealth.data.weight.Weight
import com.dzeio.openhealth.databinding.LayoutItemWeightBinding

class WeightAdapter() : BaseAdapter<Weight, LayoutItemWeightBinding>() {

    override val bindingInflater: (LayoutInflater, ViewGroup?, Boolean) -> LayoutItemWeightBinding
        get() = LayoutItemWeightBinding::inflate

    var onItemClick: ((weight: Weight) -> Unit)? = null

    override fun onBindData(
        holder: BaseViewHolder<LayoutItemWeightBinding>,
        item: Weight,
        position: Int
    ) {
        holder.binding.weight.text = "${item.weight}kg"
        holder.binding.datetime.text = item.formatTimestamp()
        holder.binding.edit.setOnClickListener {
            onItemClick?.invoke(item)
        }
    }
}